datablock ParticleData(B9ExplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.9 0.5 0.0 0.9";
   colors[1]     = "0.0 0.0 0.0 0.9";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 10.0;
   sizes[1]      = 17.0;
   sizes[2]      = 14.0;

   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 1.0;

   useInvAlpha = true;
};

datablock ParticleEmitterData(B9ExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "B9ExplosionParticle";
};

datablock ExplosionData(B9ombExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = B9ExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 10;
   radiusDamage = 170;

   impulseRadius = 6;
   impulseForce = 4000;

   playerBurnTime = 5000;
};

datablock ProjectileData(B9Projectile)
{
   projectileShapeName = "./B9ProjectileB.dts";
   directDamage        = 40;
   directDamageType = $DamageType::B9Direct;
   radiusDamageType = $DamageType::B9Radius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = B9ombExplosion;

   brickExplosionRadius = 4;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;             
   brickExplosionMaxVolume = 35;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 70;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = SpearfireSound;

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 12000;
   fadeDelay           = 11500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "B9 Bomb"; //naming it this way so it's next to the B9 in the alphabetized list
};

datablock WheeledVehicleData(B9Vehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./B9.dts";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";


shootonclick=1;
shootonclick_Hold=1;
shootonclick_ShootDelay=200;
shootonclick_ReShootDelay=200;
shootonclick_ProjectileCount=2;
shootonclick_RequiredSlot=0;
shootonclick_Sound=gunshot1sound;

shootonclick_Projectile[0]=gunProjectile;
shootonclick_Position[0]="0 0.3 2";
shootonclick_Velocity[0]="200 0 0";
shootonclick_Scale[0]="1 1 1";
shootonclick_Projectile[1]=gunProjectile;
shootonclick_Position[1]="0 -0.3 2";
shootonclick_Velocity[1]="200 0 0";
shootonclick_Scale[1]="1 1 1";

	maxDamage = 100.00;
	destroyedLevel = 100.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	// defaultTire	= B9Tire;
	// defaultSpring	= B9Spring;
	// flatTire	= B9FlatTire;
	// flatSpring	= B9FlatSpring;

   //numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 4000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 4000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 3000;
	reverseThrust		= 2000;
	lift			= 100;
	maxForwardVel		= 40;
	maxReverseVel		= 40;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 4000;
	yawForce		= 6000;
	pitchForce		= 6000;
	rotationalDrag		= 0.5;
	stallSpeed		= 10;

//   forwardThrust		= 2000;
//	reverseThrust		= 2000;
//	lift			= 100;
//	maxForwardVel		= 70;
//	maxReverseVel		= 70;
//	horizontalSurfaceForce	= 100;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 100; 
//	rollForce		= 6000;
//	yawForce		= 6000;
//	pitchForce		= 4000;
//	rotationalDrag		= 0.5;
//	stallSpeed		= 10;
//
//   forwardThrust		= 2500;
//	reverseThrust		= 500;
//	lift			= 15000;
//	maxForwardVel		= 60;
//	maxReverseVel		= 10;
//	horizontalSurfaceForce	= 500;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 500; 
//	rollForce		= 5000;
//	yawForce		= 5000;
//	pitchForce		= 5000;
//	rotationalDrag		= 0.1;
//	stallSpeed		= 10;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "B9 ";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = B9ExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = B9FinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
   
      // Advanced Steering
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   
   // minContrailSpeed = 30;
};

function B9contrailCheck(%obj)
{
	//return;
	if(!isObject(%obj))
		return;

	%speed = vectorLen(%obj.getVelocity());
	// if(%speed < %obj.dataBlock.minContrailSpeed)
	// {
		// if(%obj.getMountedImage(3) !$= "")
		// {
			// %obj.unMountImage(2);
			// %obj.unMountImage(3);
		// }
	// }
	// else
	// {
		// if(%obj.getMountedImage(3) $= 0)
		// {
			// %obj.mountImage(contrailImage1,2);
			// %obj.mountImage(contrailImage2,3);
		// }
	// }

	if(%speed < 5)
	{
		if(%obj.prop !$= "slow")
		{
			%obj.playThread(0,propslow);
			%obj.prop = "slow";
		}
	}
	else
	{
		if(%obj.prop !$= "fast")
		{
			%obj.playThread(0,propfast);
			%obj.prop = "fast";
		}
	}

	schedule(2000,0,"B9contrailCheck",%obj);
   
}










function B9vehicle::onTrigger(%this, %obj, %triggerNum, %val)
{
if(%triggerNum == 2 && %val && !iseventpending(%obj.rocketreload)){ //If they've pressed space bar and reloading isn't happening
%obj.client = %obj.getcontrollingclient(); //Find who's controlling the plane
%pos = %obj.getposition(); // Position stuff lol
%client = %obj.client; // More stuff
%pos = vectoradd(%pos,"0 0 -0.8"); // A little bit below the plane
%pos = vectoradd(%pos,%obj.getforwardvector()); // Make sure stuff's in front of the plane
%vel = "0 0 -50"; //Launch the bomb downwards so it hits something
%planevz = getword(%obj.getvelocity(),2);
if(%planevz < 0){
%vel = VectorAdd(%vel,"0 0 " @ %planevz);
}
%p = new Projectile() //Make the rocket
{
	dataBlock = B9Projectile; //Could be any projectile, but it blows up on the vehicle if it's still in contact after half a second
	initialVelocity = %vel;
	initialPosition = %pos;
	client = %obj.client;
	sourceObject = %obj.client.player;
	sourceClient = %obj.client;
};
MissionCleanup.add(%p); //Make sure stuff happens
%obj.rocketreload = schedule(500,0,""); //Reloads the rocket in one second
}
}

function untrigger(%obj, %trigger) //Makes the gun untrigger
{
%obj.setimagetrigger(%trigger,0);
}

function B9vehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);
		
	%obj.setWheelTire(0, B9tire);
	%obj.setWheelTire(1, B9tire);
	%obj.setWheelTire(2, B9acktire);

	%obj.setWheelSpring(0, B9Spring);
	%obj.setWheelSpring(1, B9Spring);
	%obj.setWheelSpring(2, B9ackSpring);
	
	%obj.setWheelSteering(0,0);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,-1);

	%obj.setWheelPowered(0,true);
    %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
	
	%obj.playthread(0,propslow);
	
	B9contrailCheck(%obj);
	    
}